-- | Wrapper type for Show instance.

{-# LANGUAGE InstanceSigs #-}
module Data.Hex (Hex(..)) where
import Numeric (showHex)

-- | Overrides the Show instance by using 'showHex' internally. The type Parameter must be an instance of 'Integral'.

newtype Hex a = Hex a

instance Integral a => Show (Hex a) where
  show :: Hex a -> String
  show (Hex x) = "Hex 0x" ++ showHex x ""

